import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkNewsCategory, ThinkNewsCategoryParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkNewsCategory(params: ThinkNewsCategoryParam) {
  const res = await request.get<ApiResult<PageResult<ThinkNewsCategory>>>(
    THINK_API_URL + '/think/think-news-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkNewsCategory(params?: ThinkNewsCategoryParam) {
  const res = await request.get<ApiResult<ThinkNewsCategory[]>>(
    THINK_API_URL + '/think/think-news-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkNewsCategory(data: ThinkNewsCategory) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkNewsCategory(data: ThinkNewsCategory) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkNewsCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkNewsCategory(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkNewsCategory(id: number) {
  const res = await request.get<ApiResult<ThinkNewsCategory>>(
    THINK_API_URL + '/think/think-news-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
